try:
    from .session_9 import *
except:
    from session_9 import *
import scipy.special as special


class NormalDistribution:
    def __init__(self, muy, sigma, x):
        check_var(muy, sigma, x)
        self.muy = muy
        self.sigma = sigma
        self.x = x
        
    def pdf(self):
        sigma = self.sigma
        muy = self.muy
        x = self.x
        re = (1/(sigma*np.sqrt(2*np.pi)))*np.exp(-((x-muy)**2)/(2*sigma**2))
        return re
    
    def cdf(self):
        sigma = self.sigma
        muy = self.muy
        x = self.x
        re = 0.5*(1+special.erf((x-muy)/(sigma*np.sqrt(2))))
        return re
    

class StandardNormalDistributiom(NormalDistribution):
    def __init__(self, x):
        super().__init__(0, 1, x)


class CentralLimitTheorem(StandardNormalDistributiom):
    def __init__(self, x, n, muyz, sigmaz):
        super().__init__(x)
        check_var(x, n, muyz, sigmaz, 0)
        
        z_score = (self.x-n*muyz)/(sigmaz*np.sqrt(n))
        self.x = z_score
        
    def cdf_inv(self):
        return 1 - self.cdf()



# demo = StandardNormalDistributiom(x=5)
# print(demo.cdf())

# demo = CentralLimitTheorem(x=500, n=1000, muy=0.513, sigma=0.499831)
# re = demo.cdf()
# print(re)
# s = 0
# for i in range(501):
#     bd = BinomialDistribution(p=0.513, n=1000, k=i, debug=0)
#     s += bd.P()
    
# print(s)

# demo = CentralLimitTheorem(x=10000, n=10000, muyz=0.97, sigmaz=13)
# r = demo.cdf_inv()
# print(r)

# demo = CentralLimitTheorem(x=60000, n=60000, muyz=0.97, sigmaz=4)
# print(demo.cdf_inv())